/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.15 Revision 1.443
1# Copyright 1999-2002 Gentoo Technologies, Inc. 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# Author: Martin Schlemmer <azarah@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.15 2003/02/02 19:43:33 azarah Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.443 2015/03/20 18:22:05 vapier Exp $
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
10ECLASS=eutils 5# @ECLASS: eutils.eclass
11INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
12 7# base-system@gentoo.org
13newdepend "!bootstrap? ( sys-devel/patch )" 8# @BLURB: many extra (but common) functions that are used in ebuilds
14 9# @DESCRIPTION:
15DESCRIPTION="Based on the ${ECLASS} eclass" 10# The eutils eclass contains a suite of functions that complement
16 11# the ones that ebuild.sh already contain. The idea is that the functions
17# This function generate linker scripts in /usr/lib for dynamic 12# are not required in all ebuilds but enough utilize them to have a common
18# libs in /lib. This is to fix linking problems when you have 13# home rather than having multiple ebuilds implementing the same thing.
19# the .so in /lib, and the .a in /usr/lib. What happens is that
20# in some cases when linking dynamic, the .a in /usr/lib is used
21# instead of the .so in /lib due to gcc/libtool tweaking ld's
22# library search path. This cause many builds to fail.
23# See bug #4411 for more info.
24# 14#
25# To use, simply call: 15# Due to the nature of this eclass, some functions may have maintainers
26# 16# different from the overall eclass!
27# gen_usr_ldscript libfoo.so
28#
29# Note that you should in general use the unversioned name of
30# the library, as ldconfig should usually update it correctly
31# to point to the latest version of the library present.
32#
33# <azarah@gentoo.org> (26 Oct 2002)
34#
35gen_usr_ldscript() {
36 17
37 # Just make sure it exists 18if [[ -z ${_EUTILS_ECLASS} ]]; then
38 dodir /usr/lib 19_EUTILS_ECLASS=1
39
40 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT"
41/* GNU ld script
42 Because Gentoo have critical dynamic libraries
43 in /lib, and the static versions in /usr/lib, we
44 need to have a "fake" dynamic lib in /usr/lib,
45 otherwise we run into linking problems.
46 See bug #4411 on http://bugs.gentoo.org/ for
47 more info. */
48GROUP ( /lib/libxxx )
49END_LDSCRIPT
50 20
51 dosed "s:libxxx:$1:" /usr/lib/$1 21inherit multilib toolchain-funcs
52 22
23if has "${EAPI:-0}" 0 1 2; then
24
25# @FUNCTION: epause
26# @USAGE: [seconds]
27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
32epause() {
33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34}
35
36# @FUNCTION: ebeep
37# @USAGE: [number of beeps]
38# @DESCRIPTION:
39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
43ebeep() {
44 local n
45 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47 echo -ne "\a"
48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49 echo -ne "\a"
50 sleep 1
51 done
52 fi
53}
54
55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="_ESTACK_$1_" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly _estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The _estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local _estack_name="_ESTACK_$1_" ; shift
137 local _estack_retvar=$1 ; shift
138 eval local _estack_i=\${#${_estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --_estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${_estack_retvar} ]] ; then
144 eval ${_estack_retvar}=\"\${${_estack_name}\[${_estack_i}\]}\"
145 fi
146 eval unset ${_estack_name}\[${_estack_i}\]
147}
148
149# @FUNCTION: evar_push
150# @USAGE: <variable to save> [more vars to save]
151# @DESCRIPTION:
152# This let's you temporarily modify a variable and then restore it (including
153# set vs unset semantics). Arrays are not supported at this time.
154#
155# This is meant for variables where using `local` does not work (such as
156# exported variables, or only temporarily changing things in a func).
157#
158# For example:
159# @CODE
160# evar_push LC_ALL
161# export LC_ALL=C
162# ... do some stuff that needs LC_ALL=C set ...
163# evar_pop
164#
165# # You can also save/restore more than one var at a time
166# evar_push BUTTERFLY IN THE SKY
167# ... do stuff with the vars ...
168# evar_pop # This restores just one var, SKY
169# ... do more stuff ...
170# evar_pop 3 # This pops the remaining 3 vars
171# @CODE
172evar_push() {
173 local var val
174 for var ; do
175 [[ ${!var+set} == "set" ]] \
176 && val=${!var} \
177 || val="unset_76fc3c462065bb4ca959f939e6793f94"
178 estack_push evar "${var}" "${val}"
179 done
180}
181
182# @FUNCTION: evar_push_set
183# @USAGE: <variable to save> [new value to store]
184# @DESCRIPTION:
185# This is a handy shortcut to save and temporarily set a variable. If a value
186# is not specified, the var will be unset.
187evar_push_set() {
188 local var=$1
189 evar_push ${var}
190 case $# in
191 1) unset ${var} ;;
192 2) printf -v "${var}" '%s' "$2" ;;
193 *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194 esac
195}
196
197# @FUNCTION: evar_pop
198# @USAGE: [number of vars to restore]
199# @DESCRIPTION:
200# Restore the variables to the state saved with the corresponding
201# evar_push call. See that function for more details.
202evar_pop() {
203 local cnt=${1:-bad}
204 case $# in
205 0) cnt=1 ;;
206 1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207 *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208 esac
209
210 local var val
211 while (( cnt-- )) ; do
212 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 [[ ${val} == "unset_76fc3c462065bb4ca959f939e6793f94" ]] \
215 && unset ${var} \
216 || printf -v "${var}" '%s' "${val}"
217 done
218}
219
220# @FUNCTION: eshopts_push
221# @USAGE: [options to `set` or `shopt`]
222# @DESCRIPTION:
223# Often times code will want to enable a shell option to change code behavior.
224# Since changing shell options can easily break other pieces of code (which
225# assume the default state), eshopts_push is used to (1) push the current shell
226# options onto a stack and (2) pass the specified arguments to set.
227#
228# If the first argument is '-s' or '-u', we assume you want to call `shopt`
229# rather than `set` as there are some options only available via that.
230#
231# A common example is to disable shell globbing so that special meaning/care
232# may be used with variables/arguments to custom functions. That would be:
233# @CODE
234# eshopts_push -o noglob
235# for x in ${foo} ; do
236# if ...some check... ; then
237# eshopts_pop
238# return 0
239# fi
240# done
241# eshopts_pop
242# @CODE
243eshopts_push() {
244 if [[ $1 == -[su] ]] ; then
245 estack_push eshopts "$(shopt -p)"
246 [[ $# -eq 0 ]] && return 0
247 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248 else
249 estack_push eshopts $-
250 [[ $# -eq 0 ]] && return 0
251 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252 fi
253}
254
255# @FUNCTION: eshopts_pop
256# @USAGE:
257# @DESCRIPTION:
258# Restore the shell options to the state saved with the corresponding
259# eshopts_push call. See that function for more details.
260eshopts_pop() {
261 local s
262 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263 if [[ ${s} == "shopt -"* ]] ; then
264 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265 else
266 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268 fi
269}
270
271# @FUNCTION: eumask_push
272# @USAGE: <new umask>
273# @DESCRIPTION:
274# Set the umask to the new value specified while saving the previous
275# value onto a stack. Useful for temporarily changing the umask.
276eumask_push() {
277 estack_push eumask "$(umask)"
278 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279}
280
281# @FUNCTION: eumask_pop
282# @USAGE:
283# @DESCRIPTION:
284# Restore the previous umask state.
285eumask_pop() {
286 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 local s
288 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290}
291
292# @FUNCTION: isdigit
293# @USAGE: <number> [more numbers]
294# @DESCRIPTION:
295# Return true if all arguments are numbers.
296isdigit() {
297 local d
298 for d ; do
299 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300 done
53 return 0 301 return 0
54} 302}
55 303
56# Simple function to draw a line consisting of '=' the same length as $* 304# @VARIABLE: EPATCH_SOURCE
57# 305# @DESCRIPTION:
58# <azarah@gentoo.org> (11 Nov 2002) 306# Default directory to search for patches.
59#
60draw_line() {
61 local i=0
62 local str_length=""
63
64 # Handle calls that do not have args, or wc not being installed ...
65 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
66 then
67 echo "==============================================================="
68 return 0
69 fi
70
71 # Get the length of $*
72 str_length="$(echo -n "$*" | wc -m)"
73
74 while [ "$i" -lt "${str_length}" ]
75 do
76 echo -n "="
77
78 i=$((i + 1))
79 done
80
81 echo
82
83 return 0
84}
85
86# Default directory where patches are located
87EPATCH_SOURCE="${WORKDIR}/patch" 307EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 308# @VARIABLE: EPATCH_SUFFIX
309# @DESCRIPTION:
310# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 311EPATCH_SUFFIX="patch.bz2"
90# Default options for patch 312# @VARIABLE: EPATCH_OPTS
313# @DESCRIPTION:
314# Options to pass to patch. Meant for ebuild/package-specific tweaking
315# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316# for single patch tweaking, you can also pass flags directly to epatch.
91EPATCH_OPTS="" 317EPATCH_OPTS=""
318# @VARIABLE: EPATCH_COMMON_OPTS
319# @DESCRIPTION:
320# Common options to pass to `patch`. You probably should never need to
321# change these. If you do, please discuss it with base-system first to
322# be sure.
323# @CODE
324# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
325# --no-backup-if-mismatch - do not leave .orig files behind
326# -E - automatically remove empty files
327# @CODE
328EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329# @VARIABLE: EPATCH_EXCLUDE
330# @DESCRIPTION:
92# List of patches not to apply. Not this is only file names, 331# List of patches not to apply. Note this is only file names,
93# and not the full path .. 332# and not the full path. Globs accepted.
94EPATCH_EXCLUDE="" 333EPATCH_EXCLUDE=""
334# @VARIABLE: EPATCH_SINGLE_MSG
335# @DESCRIPTION:
95# Change the printed message for a single patch. 336# Change the printed message for a single patch.
96EPATCH_SINGLE_MSG="" 337EPATCH_SINGLE_MSG=""
338# @VARIABLE: EPATCH_MULTI_MSG
339# @DESCRIPTION:
340# Change the printed message for multiple patches.
341EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
342# @VARIABLE: EPATCH_FORCE
343# @DESCRIPTION:
344# Only require patches to match EPATCH_SUFFIX rather than the extended
345# arch naming style.
346EPATCH_FORCE="no"
347# @VARIABLE: EPATCH_USER_EXCLUDE
348# @DEFAULT_UNSET
349# @DESCRIPTION:
350# List of patches not to apply. Note this is only file names,
351# and not the full path. Globs accepted.
97 352
98# This function is for bulk patching, or in theory for just one 353# @FUNCTION: epatch
99# or two patches. 354# @USAGE: [options] [patches] [dirs of patches]
355# @DESCRIPTION:
356# epatch is designed to greatly simplify the application of patches. It can
357# process patch files directly, or directories of patches. The patches may be
358# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
359# the -p option as epatch will automatically attempt -p0 to -p4 until things
360# apply successfully.
100# 361#
101# It should work with .bz2, .gz, .zip and plain text patches. 362# If you do not specify any patches/dirs, then epatch will default to the
102# Currently all patches should be the same format. 363# directory specified by EPATCH_SOURCE.
103# 364#
104# You do not have to specify '-p' option to patch, as it will 365# Any options specified that start with a dash will be passed down to patch
105# try with -p0 to -p5 until it succeed, or fail at -p5. 366# for this specific invocation. As soon as an arg w/out a dash is found, then
367# arg processing stops.
106# 368#
107# Above EPATCH_* variables can be used to control various defaults, 369# When processing directories, epatch will apply all patches that match:
108# bug they should be left as is to ensure an ebuild can rely on 370# @CODE
109# them for. 371# if ${EPATCH_FORCE} != "yes"
110#
111# Patches are applied in current directory.
112#
113# Bulk Patches should preferibly have the form of:
114#
115# ??_${ARCH}_foo.${EPATCH_SUFFIX} 372# ??_${ARCH}_foo.${EPATCH_SUFFIX}
373# else
374# *.${EPATCH_SUFFIX}
375# @CODE
376# The leading ?? are typically numbers used to force consistent patch ordering.
377# The arch field is used to apply patches only for the host architecture with
378# the special value of "all" means apply for everyone. Note that using values
379# other than "all" is highly discouraged -- you should apply patches all the
380# time and let architecture details be detected at configure/compile time.
116# 381#
117# For example: 382# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383# for patches to apply.
118# 384#
119# 01_all_misc-fix.patch.bz2 385# Refer to the other EPATCH_xxx variables for more customization of behavior.
120# 02_sparc_another-fix.patch.bz2
121#
122# This ensures that there are a set order, and you can have ARCH
123# specific patches.
124#
125# If you however give an argument to epatch(), it will treat it as a
126# single patch that need to be applied if its a file. If on the other
127# hand its a directory, it will set EPATCH_SOURCE to this.
128#
129# <azarah@gentoo.org> (10 Nov 2002)
130#
131epatch() { 386epatch() {
132 local PIPE_CMD="" 387 _epatch_draw_line() {
133 local STDERR_TARGET="${T}/$$.out" 388 # create a line of same length as input string
134 local PATCH_TARGET="${T}/$$.patch" 389 [[ -z $1 ]] && set "$(printf "%65s" '')"
135 local PATCH_SUFFIX="" 390 echo "${1//?/=}"
391 }
392
393 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
394
395 # First process options. We localize the EPATCH_OPTS setting
396 # from above so that we can pass it on in the loop below with
397 # any additional values the user has specified.
398 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399 while [[ $# -gt 0 ]] ; do
400 case $1 in
401 -*) EPATCH_OPTS+=( "$1" ) ;;
402 *) break ;;
403 esac
404 shift
405 done
406
407 # Let the rest of the code process one user arg at a time --
408 # each arg may expand into multiple patches, and each arg may
409 # need to start off with the default global EPATCH_xxx values
410 if [[ $# -gt 1 ]] ; then
411 local m
412 for m in "$@" ; do
413 epatch "${m}"
414 done
415 return 0
416 fi
417
136 local SINGLE_PATCH="no" 418 local SINGLE_PATCH="no"
137 local x="" 419 # no args means process ${EPATCH_SOURCE}
420 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
138 421
139 if [ "$#" -gt 1 ] 422 if [[ -f $1 ]] ; then
140 then
141 eerror "Invalid arguments to epatch()"
142 die "Invalid arguments to epatch()"
143 fi
144
145 if [ -n "$1" -a -f "$1" ]
146 then
147 SINGLE_PATCH="yes" 423 SINGLE_PATCH="yes"
148 424 set -- "$1"
149 local EPATCH_SOURCE="$1" 425 # Use the suffix from the single patch (localize it); the code
426 # below will find the suffix for us
150 local EPATCH_SUFFIX="${1##*\.}" 427 local EPATCH_SUFFIX=$1
151 428
152 elif [ -n "$1" -a -d "$1" ] 429 elif [[ -d $1 ]] ; then
153 then 430 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
154 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 431 evar_push_set LC_COLLATE C
432 # Some people like to make dirs of patches w/out suffixes (vim).
433 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434 evar_pop
435
436 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437 # Re-use EPATCH_SOURCE as a search dir
438 epatch "${EPATCH_SOURCE}/$1"
439 return $?
440
155 else 441 else
156 if [ ! -d ${EPATCH_SOURCE} ] 442 # sanity check ... if it isn't a dir or file, wtf man ?
443 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
444 echo
445 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
446 eerror
447 eerror " ${EPATCH_SOURCE}"
448 eerror " ( ${EPATCH_SOURCE##*/} )"
449 echo
450 die "Cannot find \$EPATCH_SOURCE!"
451 fi
452
453 # Now that we know we're actually going to apply something, merge
454 # all of the patch options back in to a single variable for below.
455 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456
457 local PIPE_CMD
458 case ${EPATCH_SUFFIX##*\.} in
459 xz) PIPE_CMD="xz -dc" ;;
460 lzma) PIPE_CMD="lzma -dc" ;;
461 bz2) PIPE_CMD="bzip2 -dc" ;;
462 gz|Z|z) PIPE_CMD="gzip -dc" ;;
463 ZIP|zip) PIPE_CMD="unzip -p" ;;
464 *) ;;
465 esac
466
467 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
468
469 local x
470 for x in "$@" ; do
471 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
472 # didn't match anything, ignore continue on
473 [[ ! -f ${x} ]] && continue
474
475 local patchname=${x##*/}
476
477 # Apply single patches, or forced sets of patches, or
478 # patches with ARCH dependant names.
479 # ???_arch_foo.patch
480 # Else, skip this input altogether
481 local a=${patchname#*_} # strip the ???_
482 a=${a%%_*} # strip the _foo.patch
483 if ! [[ ${SINGLE_PATCH} == "yes" || \
484 ${EPATCH_FORCE} == "yes" || \
485 ${a} == all || \
486 ${a} == ${ARCH} ]]
157 then 487 then
488 continue
489 fi
490
491 # Let people filter things dynamically
492 if [[ -n ${EPATCH_EXCLUDE}${EPATCH_USER_EXCLUDE} ]] ; then
493 # let people use globs in the exclude
494 eshopts_push -o noglob
495
496 local ex
497 for ex in ${EPATCH_EXCLUDE} ; do
498 if [[ ${patchname} == ${ex} ]] ; then
499 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500 eshopts_pop
501 continue 2
502 fi
503 done
504
505 for ex in ${EPATCH_USER_EXCLUDE} ; do
506 if [[ ${patchname} == ${ex} ]] ; then
507 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
508 eshopts_pop
509 continue 2
510 fi
511 done
512
513 eshopts_pop
514 fi
515
516 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
517 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
518 einfo "${EPATCH_SINGLE_MSG}"
519 else
520 einfo "Applying ${patchname} ..."
521 fi
522 else
523 einfo " ${patchname} ..."
524 fi
525
526 # Handle aliased patch command #404447 #461568
527 local patch="patch"
528 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
529
530 # most of the time, there will only be one run per unique name,
531 # but if there are more, make sure we get unique log filenames
532 local STDERR_TARGET="${T}/${patchname}.out"
533 if [[ -e ${STDERR_TARGET} ]] ; then
534 STDERR_TARGET="${T}/${patchname}-$$.out"
535 fi
536
537 printf "***** %s *****\nPWD: %s\nPATCH TOOL: %s -> %s\nVERSION INFO:\n%s\n\n" \
538 "${patchname}" \
539 "${PWD}" \
540 "${patch}" \
541 "$(type -P "${patch}")" \
542 "$(${patch} --version)" \
543 > "${STDERR_TARGET}"
544
545 # Decompress the patch if need be
546 local count=0
547 local PATCH_TARGET
548 if [[ -n ${PIPE_CMD} ]] ; then
549 PATCH_TARGET="${T}/$$.patch"
550 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
551
552 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
553 echo
554 eerror "Could not extract patch!"
555 #die "Could not extract patch!"
556 count=5
557 break
558 fi
559 else
560 PATCH_TARGET=${x}
561 fi
562
563 # Check for absolute paths in patches. If sandbox is disabled,
564 # people could (accidently) patch files in the root filesystem.
565 # Or trigger other unpleasantries #237667. So disallow -p0 on
566 # such patches.
567 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
568 if [[ -n ${abs_paths} ]] ; then
569 count=1
570 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
571 fi
572 # Similar reason, but with relative paths.
573 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
574 if [[ -n ${rel_paths} ]] ; then
158 echo 575 echo
159 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 576 eerror "Rejected Patch: ${patchname} !"
577 eerror " ( ${PATCH_TARGET} )"
160 eerror 578 eerror
161 eerror " ${EPATCH_SOURCE}" 579 eerror "Your patch uses relative paths '../':"
580 eerror "${rel_paths}"
162 echo 581 echo
163 die "Cannot find \$EPATCH_SOURCE!" 582 die "you need to fix the relative paths in patch"
583 fi
584
585 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
586 local patch_cmd
587 while [[ ${count} -lt 5 ]] ; do
588 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
589
590 # Generate some useful debug info ...
591 (
592 _epatch_draw_line "***** ${patchname} *****"
593 echo
594 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
595 echo
596 _epatch_draw_line "***** ${patchname} *****"
597 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
598 ret=$?
599 echo
600 echo "patch program exited with status ${ret}"
601 exit ${ret}
602 ) >> "${STDERR_TARGET}"
603
604 if [ $? -eq 0 ] ; then
605 (
606 _epatch_draw_line "***** ${patchname} *****"
607 echo
608 echo "ACTUALLY APPLYING ${patchname} ..."
609 echo
610 _epatch_draw_line "***** ${patchname} *****"
611 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
612 ret=$?
613 echo
614 echo "patch program exited with status ${ret}"
615 exit ${ret}
616 ) >> "${STDERR_TARGET}"
617
618 if [ $? -ne 0 ] ; then
619 echo
620 eerror "A dry-run of patch command succeeded, but actually"
621 eerror "applying the patch failed!"
622 #die "Real world sux compared to the dreamworld!"
623 count=5
624 fi
625 break
164 fi 626 fi
165 627
166 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}" 628 : $(( count++ ))
629 done
630
631 # if we had to decompress the patch, delete the temp one
632 if [[ -n ${PIPE_CMD} ]] ; then
633 rm -f "${PATCH_TARGET}"
167 fi 634 fi
168 635
169 case ${EPATCH_SUFFIX##*\.} in 636 if [[ ${count} -ge 5 ]] ; then
170 bz2) 637 echo
171 PIPE_CMD="bzip2 -dc" 638 eerror "Failed Patch: ${patchname} !"
639 eerror " ( ${PATCH_TARGET} )"
640 eerror
641 eerror "Include in your bugreport the contents of:"
642 eerror
643 eerror " ${STDERR_TARGET}"
644 echo
645 die "Failed Patch: ${patchname}!"
646 fi
647
648 # if everything worked, delete the full debug patch log
649 rm -f "${STDERR_TARGET}"
650
651 # then log away the exact stuff for people to review later
652 cat <<-EOF >> "${T}/epatch.log"
653 PATCH: ${x}
654 CMD: ${patch_cmd}
655 PWD: ${PWD}
656
657 EOF
658 eend 0
659 done
660
661 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
662 : # everything worked
663}
664
665# @FUNCTION: epatch_user
666# @USAGE:
667# @DESCRIPTION:
668# Applies user-provided patches to the source tree. The patches are
669# taken from /etc/portage/patches/<CATEGORY>/<P-PR|P|PN>[:SLOT]/, where the first
670# of these three directories to exist will be the one to use, ignoring
671# any more general directories which might exist as well. They must end
672# in ".patch" to be applied.
673#
674# User patches are intended for quick testing of patches without ebuild
675# modifications, as well as for permanent customizations a user might
676# desire. Obviously, there can be no official support for arbitrarily
677# patched ebuilds. So whenever a build log in a bug report mentions that
678# user patches were applied, the user should be asked to reproduce the
679# problem without these.
680#
681# Not all ebuilds do call this function, so placing patches in the
682# stated directory might or might not work, depending on the package and
683# the eclasses it inherits and uses. It is safe to call the function
684# repeatedly, so it is always possible to add a call at the ebuild
685# level. The first call is the time when the patches will be
686# applied.
687#
688# Ideally, this function should be called after gentoo-specific patches
689# have been applied, so that their code can be modified as well, but
690# before calls to e.g. eautoreconf, as the user patches might affect
691# autotool input files as well.
692epatch_user() {
693 [[ $# -ne 0 ]] && die "epatch_user takes no options"
694
695 # Allow multiple calls to this function; ignore all but the first
696 local applied="${T}/epatch_user.log"
697 [[ -e ${applied} ]] && return 2
698
699 # don't clobber any EPATCH vars that the parent might want
700 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
701 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
702 EPATCH_SOURCE=${base}/${CTARGET}/${check}
703 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
704 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
705 if [[ -d ${EPATCH_SOURCE} ]] ; then
706 EPATCH_SOURCE=${EPATCH_SOURCE} \
172 PATCH_SUFFIX="bz2" 707 EPATCH_SUFFIX="patch" \
708 EPATCH_FORCE="yes" \
709 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
710 epatch
711 echo "${EPATCH_SOURCE}" > "${applied}"
712 return 0
713 fi
714 done
715 echo "none" > "${applied}"
716 return 1
717}
718
719# @FUNCTION: emktemp
720# @USAGE: [temp dir]
721# @DESCRIPTION:
722# Cheap replacement for when debianutils (and thus mktemp)
723# does not exist on the users system.
724emktemp() {
725 local exe="touch"
726 [[ $1 == -d ]] && exe="mkdir" && shift
727 local topdir=$1
728
729 if [[ -z ${topdir} ]] ; then
730 [[ -z ${T} ]] \
731 && topdir="/tmp" \
732 || topdir=${T}
733 fi
734
735 if ! type -P mktemp > /dev/null ; then
736 # system lacks `mktemp` so we have to fake it
737 local tmp=/
738 while [[ -e ${tmp} ]] ; do
739 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
740 done
741 ${exe} "${tmp}" || ${exe} -p "${tmp}"
742 echo "${tmp}"
743 else
744 # the args here will give slightly wierd names on BSD,
745 # but should produce a usable file on all userlands
746 if [[ ${exe} == "touch" ]] ; then
747 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
748 else
749 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
750 fi
751 fi
752}
753
754# @FUNCTION: edos2unix
755# @USAGE: <file> [more files ...]
756# @DESCRIPTION:
757# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
758# to remove all of these text utilities from DEPEND variables because this
759# is a script based solution. Just give it a list of files to convert and
760# they will all be changed from the DOS CRLF format to the UNIX LF format.
761edos2unix() {
762 [[ $# -eq 0 ]] && return 0
763 sed -i 's/\r$//' -- "$@" || die
764}
765
766# @FUNCTION: make_desktop_entry
767# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
768# @DESCRIPTION:
769# Make a .desktop file.
770#
771# @CODE
772# binary: what command does the app run with ?
773# name: the name that will show up in the menu
774# icon: the icon to use in the menu entry
775# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon
777# type: what kind of application is this?
778# for categories:
779# http://standards.freedesktop.org/menu-spec/latest/apa.html
780# if unset, function tries to guess from package's category
781# fields: extra fields to append to the desktop file; a printf string
782# @CODE
783make_desktop_entry() {
784 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
785
786 local exec=${1}
787 local name=${2:-${PN}}
788 local icon=${3:-${PN}}
789 local type=${4}
790 local fields=${5}
791
792 if [[ -z ${type} ]] ; then
793 local catmaj=${CATEGORY%%-*}
794 local catmin=${CATEGORY##*-}
795 case ${catmaj} in
796 app)
797 case ${catmin} in
798 accessibility) type="Utility;Accessibility";;
799 admin) type=System;;
800 antivirus) type=System;;
801 arch) type="Utility;Archiving";;
802 backup) type="Utility;Archiving";;
803 cdr) type="AudioVideo;DiscBurning";;
804 dicts) type="Office;Dictionary";;
805 doc) type=Documentation;;
806 editors) type="Utility;TextEditor";;
807 emacs) type="Development;TextEditor";;
808 emulation) type="System;Emulator";;
809 laptop) type="Settings;HardwareSettings";;
810 office) type=Office;;
811 pda) type="Office;PDA";;
812 vim) type="Development;TextEditor";;
813 xemacs) type="Development;TextEditor";;
814 esac
173 ;; 815 ;;
174 gz|Z|z) 816
175 PIPE_CMD="gzip -dc" 817 dev)
176 PATCH_SUFFIX="gz" 818 type="Development"
177 ;; 819 ;;
178 ZIP|zip) 820
179 PIPE_CMD="unzip -p" 821 games)
180 PATCH_SUFFIX="zip" 822 case ${catmin} in
823 action|fps) type=ActionGame;;
824 arcade) type=ArcadeGame;;
825 board) type=BoardGame;;
826 emulation) type=Emulator;;
827 kids) type=KidsGame;;
828 puzzle) type=LogicGame;;
829 roguelike) type=RolePlaying;;
830 rpg) type=RolePlaying;;
831 simulation) type=Simulation;;
832 sports) type=SportsGame;;
833 strategy) type=StrategyGame;;
834 esac
835 type="Game;${type}"
181 ;; 836 ;;
837
838 gnome)
839 type="Gnome;GTK"
840 ;;
841
842 kde)
843 type="KDE;Qt"
844 ;;
845
846 mail)
847 type="Network;Email"
848 ;;
849
850 media)
851 case ${catmin} in
852 gfx)
853 type=Graphics
854 ;;
855 *)
856 case ${catmin} in
857 radio) type=Tuner;;
858 sound) type=Audio;;
859 tv) type=TV;;
860 video) type=Video;;
861 esac
862 type="AudioVideo;${type}"
863 ;;
864 esac
865 ;;
866
867 net)
868 case ${catmin} in
869 dialup) type=Dialup;;
870 ftp) type=FileTransfer;;
871 im) type=InstantMessaging;;
872 irc) type=IRCClient;;
873 mail) type=Email;;
874 news) type=News;;
875 nntp) type=News;;
876 p2p) type=FileTransfer;;
877 voip) type=Telephony;;
878 esac
879 type="Network;${type}"
880 ;;
881
882 sci)
883 case ${catmin} in
884 astro*) type=Astronomy;;
885 bio*) type=Biology;;
886 calc*) type=Calculator;;
887 chem*) type=Chemistry;;
888 elec*) type=Electronics;;
889 geo*) type=Geology;;
890 math*) type=Math;;
891 physics) type=Physics;;
892 visual*) type=DataVisualization;;
893 esac
894 type="Education;Science;${type}"
895 ;;
896
897 sys)
898 type="System"
899 ;;
900
901 www)
902 case ${catmin} in
903 client) type=WebBrowser;;
904 esac
905 type="Network;${type}"
906 ;;
907
908 *)
909 type=
910 ;;
911 esac
912 fi
913 local slot=${SLOT%/*}
914 if [[ ${slot} == "0" ]] ; then
915 local desktop_name="${PN}"
916 else
917 local desktop_name="${PN}-${slot}"
918 fi
919 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
920 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
921
922 # Don't append another ";" when a valid category value is provided.
923 type=${type%;}${type:+;}
924
925 eshopts_push -s extglob
926 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
927 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
928 ewarn "allowed in .desktop files if the value is not an absolute path."
929 icon=${icon%.@(xpm|png|svg)}
930 fi
931 eshopts_pop
932
933 cat <<-EOF > "${desktop}"
934 [Desktop Entry]
935 Name=${name}
936 Type=Application
937 Comment=${DESCRIPTION}
938 Exec=${exec}
939 TryExec=${exec%% *}
940 Icon=${icon}
941 Categories=${type}
942 EOF
943
944 if [[ ${fields:-=} != *=* ]] ; then
945 # 5th arg used to be value to Path=
946 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
947 fields="Path=${fields}"
948 fi
949 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
950
951 (
952 # wrap the env here so that the 'insinto' call
953 # doesn't corrupt the env of the caller
954 insinto /usr/share/applications
955 doins "${desktop}"
956 ) || die "installing desktop file failed"
957}
958
959# @FUNCTION: _eutils_eprefix_init
960# @INTERNAL
961# @DESCRIPTION:
962# Initialized prefix variables for EAPI<3.
963_eutils_eprefix_init() {
964 has "${EAPI:-0}" 0 1 2 && : ${ED:=${D}} ${EPREFIX:=} ${EROOT:=${ROOT}}
965}
966
967# @FUNCTION: validate_desktop_entries
968# @USAGE: [directories]
969# @MAINTAINER:
970# Carsten Lohrke <carlo@gentoo.org>
971# @DESCRIPTION:
972# Validate desktop entries using desktop-file-utils
973validate_desktop_entries() {
974 _eutils_eprefix_init
975 if [[ -x "${EPREFIX}"/usr/bin/desktop-file-validate ]] ; then
976 einfo "Checking desktop entry validity"
977 local directories=""
978 for d in /usr/share/applications $@ ; do
979 [[ -d ${ED}${d} ]] && directories="${directories} ${ED}${d}"
980 done
981 if [[ -n ${directories} ]] ; then
982 for FILE in $(find ${directories} -name "*\.desktop" \
983 -not -path '*.hidden*' | sort -u 2>/dev/null)
984 do
985 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
986 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
987 [[ -n $temp ]] && elog ${temp/--/${FILE/${ED}/}:}
988 done
989 fi
990 echo ""
991 else
992 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
993 fi
994}
995
996# @FUNCTION: make_session_desktop
997# @USAGE: <title> <command> [command args...]
998# @DESCRIPTION:
999# Make a GDM/KDM Session file. The title is the file to execute to start the
1000# Window Manager. The command is the name of the Window Manager.
1001#
1002# You can set the name of the file via the ${wm} variable.
1003make_session_desktop() {
1004 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1005 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1006
1007 local title=$1
1008 local command=$2
1009 local desktop=${T}/${wm:-${PN}}.desktop
1010 shift 2
1011
1012 cat <<-EOF > "${desktop}"
1013 [Desktop Entry]
1014 Name=${title}
1015 Comment=This session logs you into ${title}
1016 Exec=${command} $*
1017 TryExec=${command}
1018 Type=XSession
1019 EOF
1020
1021 (
1022 # wrap the env here so that the 'insinto' call
1023 # doesn't corrupt the env of the caller
1024 insinto /usr/share/xsessions
1025 doins "${desktop}"
1026 )
1027}
1028
1029# @FUNCTION: domenu
1030# @USAGE: <menus>
1031# @DESCRIPTION:
1032# Install the list of .desktop menu files into the appropriate directory
1033# (/usr/share/applications).
1034domenu() {
1035 (
1036 # wrap the env here so that the 'insinto' call
1037 # doesn't corrupt the env of the caller
1038 local i j ret=0
1039 insinto /usr/share/applications
1040 for i in "$@" ; do
1041 if [[ -f ${i} ]] ; then
1042 doins "${i}"
1043 ((ret+=$?))
1044 elif [[ -d ${i} ]] ; then
1045 for j in "${i}"/*.desktop ; do
1046 doins "${j}"
1047 ((ret+=$?))
1048 done
1049 else
1050 ((++ret))
1051 fi
1052 done
1053 exit ${ret}
1054 )
1055}
1056
1057# @FUNCTION: newmenu
1058# @USAGE: <menu> <newname>
1059# @DESCRIPTION:
1060# Like all other new* functions, install the specified menu as newname.
1061newmenu() {
1062 (
1063 # wrap the env here so that the 'insinto' call
1064 # doesn't corrupt the env of the caller
1065 insinto /usr/share/applications
1066 newins "$@"
1067 )
1068}
1069
1070# @FUNCTION: _iconins
1071# @INTERNAL
1072# @DESCRIPTION:
1073# function for use in doicon and newicon
1074_iconins() {
1075 (
1076 # wrap the env here so that the 'insinto' call
1077 # doesn't corrupt the env of the caller
1078 local funcname=$1; shift
1079 local size dir
1080 local context=apps
1081 local theme=hicolor
1082
1083 while [[ $# -gt 0 ]] ; do
1084 case $1 in
1085 -s|--size)
1086 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1087 size=${2%%x*}
1088 else
1089 size=${2}
1090 fi
1091 case ${size} in
1092 16|22|24|32|36|48|64|72|96|128|192|256|512)
1093 size=${size}x${size};;
1094 scalable)
1095 ;;
1096 *)
1097 eerror "${size} is an unsupported icon size!"
1098 exit 1;;
1099 esac
1100 shift 2;;
1101 -t|--theme)
1102 theme=${2}
1103 shift 2;;
1104 -c|--context)
1105 context=${2}
1106 shift 2;;
182 *) 1107 *)
183 PIPE_CMD="cat" 1108 if [[ -z ${size} ]] ; then
184 PATCH_SUFFIX="patch" 1109 insinto /usr/share/pixmaps
185 ;; 1110 else
186 esac 1111 insinto /usr/share/icons/${theme}/${size}/${context}
187
188 if [ "${SINGLE_PATCH}" = "no" ]
189 then
190 einfo "Applying various patches (bugfixes/updates)..."
191 fi
192 for x in ${EPATCH_SOURCE}
193 do
194 # New ARCH dependant patch naming scheme...
195 #
196 # ???_arch_foo.patch
197 #
198 if [ -f ${x} ] && \
199 [ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ]
200 then
201 local count=0
202 local popts="${EPATCH_OPTS}"
203
204 if [ -n "${EPATCH_EXCLUDE}" ]
205 then
206 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
207 then
208 continue
209 fi
210 fi 1112 fi
211 1113
212 if [ "${SINGLE_PATCH}" = "yes" ] 1114 if [[ ${funcname} == doicon ]] ; then
213 then 1115 if [[ -f $1 ]] ; then
214 if [ -n "${EPATCH_SINGLE_MSG}" ] 1116 doins "${1}"
215 then 1117 elif [[ -d $1 ]] ; then
216 einfo "${EPATCH_SINGLE_MSG}" 1118 shopt -s nullglob
1119 doins "${1}"/*.{png,svg}
1120 shopt -u nullglob
217 else 1121 else
218 einfo "Applying ${x##*/}..." 1122 eerror "${1} is not a valid file/directory!"
1123 exit 1
219 fi 1124 fi
220 else 1125 else
221 einfo " ${x##*/}..." 1126 break
222 fi 1127 fi
1128 shift 1;;
1129 esac
1130 done
1131 if [[ ${funcname} == newicon ]] ; then
1132 newins "$@"
1133 fi
1134 ) || die
1135}
223 1136
224 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1137# @FUNCTION: doicon
225 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1138# @USAGE: [options] <icons>
1139# @DESCRIPTION:
1140# Install icon into the icon directory /usr/share/icons or into
1141# /usr/share/pixmaps if "--size" is not set.
1142# This is useful in conjunction with creating desktop/menu files.
1143#
1144# @CODE
1145# options:
1146# -s, --size
1147# !!! must specify to install into /usr/share/icons/... !!!
1148# size of the icon, like 48 or 48x48
1149# supported icon sizes are:
1150# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1151# -c, --context
1152# defaults to "apps"
1153# -t, --theme
1154# defaults to "hicolor"
1155#
1156# icons: list of icons
1157#
1158# example 1: doicon foobar.png fuqbar.svg suckbar.png
1159# results in: insinto /usr/share/pixmaps
1160# doins foobar.png fuqbar.svg suckbar.png
1161#
1162# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1163# results in: insinto /usr/share/icons/hicolor/48x48/apps
1164# doins foobar.png fuqbar.png blobbar.png
1165# @CODE
1166doicon() {
1167 _iconins ${FUNCNAME} "$@"
1168}
226 1169
227 # Allow for prefix to differ ... im lazy, so shoot me :/ 1170# @FUNCTION: newicon
228 while [ "${count}" -lt 5 ] 1171# @USAGE: [options] <icon> <newname>
229 do 1172# @DESCRIPTION:
230 # Generate some useful debug info ... 1173# Like doicon, install the specified icon as newname.
231 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1174#
232 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1175# @CODE
1176# example 1: newicon foobar.png NEWNAME.png
1177# results in: insinto /usr/share/pixmaps
1178# newins foobar.png NEWNAME.png
1179#
1180# example 2: newicon -s 48 foobar.png NEWNAME.png
1181# results in: insinto /usr/share/icons/hicolor/48x48/apps
1182# newins foobar.png NEWNAME.png
1183# @CODE
1184newicon() {
1185 _iconins ${FUNCNAME} "$@"
1186}
233 1187
234 if [ "${PATCH_SUFFIX}" != "patch" ] 1188# @FUNCTION: strip-linguas
235 then 1189# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
236 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1190# @DESCRIPTION:
237 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1191# Make sure that LINGUAS only contains languages that
1192# a package can support. The first form allows you to
1193# specify a list of LINGUAS. The -i builds a list of po
1194# files found in all the directories and uses the
1195# intersection of the lists. The -u builds a list of po
1196# files found in all the directories and uses the union
1197# of the lists.
1198strip-linguas() {
1199 local ls newls nols
1200 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1201 local op=$1; shift
1202 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1203 local d f
1204 for d in "$@" ; do
1205 if [[ ${op} == "-u" ]] ; then
1206 newls=${ls}
1207 else
1208 newls=""
1209 fi
1210 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1211 if [[ ${op} == "-i" ]] ; then
1212 has ${f} ${ls} && newls="${newls} ${f}"
238 else 1213 else
239 PATCH_TARGET="${x}" 1214 has ${f} ${ls} || newls="${newls} ${f}"
240 fi 1215 fi
241 1216 done
242 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1217 ls=${newls}
243 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1218 done
244 1219 else
245 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1220 ls="$@"
246 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1221 fi
247 1222
248 if [ "${PATCH_SUFFIX}" != "patch" ] 1223 nols=""
249 then 1224 newls=""
250 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1 1225 for f in ${LINGUAS} ; do
251 then 1226 if has ${f} ${ls} ; then
252 echo 1227 newls="${newls} ${f}"
253 eerror "Could not extract patch!" 1228 else
254 #die "Could not extract patch!" 1229 nols="${nols} ${f}"
255 count=5 1230 fi
1231 done
1232 [[ -n ${nols} ]] \
1233 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1234 export LINGUAS=${newls:1}
1235}
1236
1237# @FUNCTION: preserve_old_lib
1238# @USAGE: <libs to preserve> [more libs]
1239# @DESCRIPTION:
1240# These functions are useful when a lib in your package changes ABI SONAME.
1241# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1242# would break packages that link against it. Most people get around this
1243# by using the portage SLOT mechanism, but that is not always a relevant
1244# solution, so instead you can call this from pkg_preinst. See also the
1245# preserve_old_lib_notify function.
1246preserve_old_lib() {
1247 _eutils_eprefix_init
1248 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1249 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1250 die "Invalid preserve_old_lib() usage"
1251 fi
1252 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1253
1254 # let portage worry about it
1255 has preserve-libs ${FEATURES} && return 0
1256
1257 local lib dir
1258 for lib in "$@" ; do
1259 [[ -e ${EROOT}/${lib} ]] || continue
1260 dir=${lib%/*}
1261 dodir ${dir} || die "dodir ${dir} failed"
1262 cp "${EROOT}"/${lib} "${ED}"/${lib} || die "cp ${lib} failed"
1263 touch "${ED}"/${lib}
1264 done
1265}
1266
1267# @FUNCTION: preserve_old_lib_notify
1268# @USAGE: <libs to notify> [more libs]
1269# @DESCRIPTION:
1270# Spit helpful messages about the libraries preserved by preserve_old_lib.
1271preserve_old_lib_notify() {
1272 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1273 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1274 die "Invalid preserve_old_lib_notify() usage"
1275 fi
1276
1277 # let portage worry about it
1278 has preserve-libs ${FEATURES} && return 0
1279
1280 _eutils_eprefix_init
1281
1282 local lib notice=0
1283 for lib in "$@" ; do
1284 [[ -e ${EROOT}/${lib} ]] || continue
1285 if [[ ${notice} -eq 0 ]] ; then
1286 notice=1
1287 ewarn "Old versions of installed libraries were detected on your system."
1288 ewarn "In order to avoid breaking packages that depend on these old libs,"
1289 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1290 ewarn "in order to remove these old dependencies. If you do not have this"
1291 ewarn "helper program, simply emerge the 'gentoolkit' package."
1292 ewarn
1293 fi
1294 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1295 done
1296}
1297
1298# @FUNCTION: built_with_use
1299# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1300# @DESCRIPTION:
1301#
1302# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1303#
1304# A temporary hack until portage properly supports DEPENDing on USE
1305# flags being enabled in packages. This will check to see if the specified
1306# DEPEND atom was built with the specified list of USE flags. The
1307# --missing option controls the behavior if called on a package that does
1308# not actually support the defined USE flags (aka listed in IUSE).
1309# The default is to abort (call die). The -a and -o flags control
1310# the requirements of the USE flags. They correspond to "and" and "or"
1311# logic. So the -a flag means all listed USE flags must be enabled
1312# while the -o flag means at least one of the listed IUSE flags must be
1313# enabled. The --hidden option is really for internal use only as it
1314# means the USE flag we're checking is hidden expanded, so it won't be found
1315# in IUSE like normal USE flags.
1316#
1317# Remember that this function isn't terribly intelligent so order of optional
1318# flags matter.
1319built_with_use() {
1320 _eutils_eprefix_init
1321 local hidden="no"
1322 if [[ $1 == "--hidden" ]] ; then
1323 hidden="yes"
1324 shift
1325 fi
1326
1327 local missing_action="die"
1328 if [[ $1 == "--missing" ]] ; then
1329 missing_action=$2
1330 shift ; shift
1331 case ${missing_action} in
1332 true|false|die) ;;
1333 *) die "unknown action '${missing_action}'";;
1334 esac
1335 fi
1336
1337 local opt=$1
1338 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1339
1340 local PKG=$(best_version $1)
1341 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1342 shift
1343
1344 local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
1345 local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
1346
1347 # if the IUSE file doesn't exist, the read will error out, we need to handle
1348 # this gracefully
1349 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1350 case ${missing_action} in
1351 true) return 0;;
1352 false) return 1;;
1353 die) die "Unable to determine what USE flags $PKG was built with";;
1354 esac
1355 fi
1356
1357 if [[ ${hidden} == "no" ]] ; then
1358 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1359 # Don't check USE_EXPAND #147237
1360 local expand
1361 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1362 if [[ $1 == ${expand}_* ]] ; then
1363 expand=""
256 break 1364 break
1365 fi
1366 done
1367 if [[ -n ${expand} ]] ; then
1368 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1369 case ${missing_action} in
1370 true) return 0;;
1371 false) return 1;;
1372 die) die "$PKG does not actually support the $1 USE flag!";;
1373 esac
1374 fi
1375 fi
1376 fi
1377
1378 local USE_BUILT=$(<${USEFILE})
1379 while [[ $# -gt 0 ]] ; do
1380 if [[ ${opt} = "-o" ]] ; then
1381 has $1 ${USE_BUILT} && return 0
1382 else
1383 has $1 ${USE_BUILT} || return 1
1384 fi
1385 shift
1386 done
1387 [[ ${opt} = "-a" ]]
1388}
1389
1390# @FUNCTION: epunt_cxx
1391# @USAGE: [dir to scan]
1392# @DESCRIPTION:
1393# Many configure scripts wrongly bail when a C++ compiler could not be
1394# detected. If dir is not specified, then it defaults to ${S}.
1395#
1396# http://bugs.gentoo.org/73450
1397epunt_cxx() {
1398 local dir=$1
1399 [[ -z ${dir} ]] && dir=${S}
1400 ebegin "Removing useless C++ checks"
1401 local f p any_found
1402 while IFS= read -r -d '' f; do
1403 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1404 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1405 any_found=1
1406 break
1407 fi
1408 done
1409 done < <(find "${dir}" -name configure -print0)
1410
1411 if [[ -z ${any_found} ]]; then
1412 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1413 fi
1414 eend 0
1415}
1416
1417# @FUNCTION: make_wrapper
1418# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1419# @DESCRIPTION:
1420# Create a shell wrapper script named wrapper in installpath
1421# (defaults to the bindir) to execute target (default of wrapper) by
1422# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1423# libpaths followed by optionally changing directory to chdir.
1424make_wrapper() {
1425 _eutils_eprefix_init
1426 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1427 local tmpwrapper=$(emktemp)
1428
1429 (
1430 echo '#!/bin/sh'
1431 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
1432 if [[ -n ${libdir} ]] ; then
1433 local var
1434 if [[ ${CHOST} == *-darwin* ]] ; then
1435 var=DYLD_LIBRARY_PATH
1436 else
1437 var=LD_LIBRARY_PATH
1438 fi
1439 cat <<-EOF
1440 if [ "\${${var}+set}" = "set" ] ; then
1441 export ${var}="\${${var}}:${EPREFIX}${libdir}"
1442 else
1443 export ${var}="${EPREFIX}${libdir}"
1444 fi
1445 EOF
1446 fi
1447 # We don't want to quote ${bin} so that people can pass complex
1448 # things as ${bin} ... "./someprog --args"
1449 printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}/}"
1450 ) > "${tmpwrapper}"
1451 chmod go+rx "${tmpwrapper}"
1452
1453 if [[ -n ${path} ]] ; then
1454 (
1455 exeinto "${path}"
1456 newexe "${tmpwrapper}" "${wrapper}"
1457 ) || die
1458 else
1459 newbin "${tmpwrapper}" "${wrapper}" || die
1460 fi
1461}
1462
1463# @FUNCTION: path_exists
1464# @USAGE: [-a|-o] <paths>
1465# @DESCRIPTION:
1466# Check if the specified paths exist. Works for all types of paths
1467# (files/dirs/etc...). The -a and -o flags control the requirements
1468# of the paths. They correspond to "and" and "or" logic. So the -a
1469# flag means all the paths must exist while the -o flag means at least
1470# one of the paths must exist. The default behavior is "and". If no
1471# paths are specified, then the return value is "false".
1472path_exists() {
1473 local opt=$1
1474 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1475
1476 # no paths -> return false
1477 # same behavior as: [[ -e "" ]]
1478 [[ $# -eq 0 ]] && return 1
1479
1480 local p r=0
1481 for p in "$@" ; do
1482 [[ -e ${p} ]]
1483 : $(( r += $? ))
1484 done
1485
1486 case ${opt} in
1487 -a) return $(( r != 0 )) ;;
1488 -o) return $(( r == $# )) ;;
1489 esac
1490}
1491
1492# @FUNCTION: in_iuse
1493# @USAGE: <flag>
1494# @DESCRIPTION:
1495# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1496# as necessary.
1497#
1498# Note that this function should not be used in the global scope.
1499in_iuse() {
1500 debug-print-function ${FUNCNAME} "${@}"
1501 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1502
1503 local flag=${1}
1504 local liuse=( ${IUSE} )
1505
1506 has "${flag}" "${liuse[@]#[+-]}"
1507}
1508
1509# @FUNCTION: use_if_iuse
1510# @USAGE: <flag>
1511# @DESCRIPTION:
1512# Return true if the given flag is in USE and IUSE.
1513#
1514# Note that this function should not be used in the global scope.
1515use_if_iuse() {
1516 in_iuse $1 || return 1
1517 use $1
1518}
1519
1520# @FUNCTION: usex
1521# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1522# @DESCRIPTION:
1523# Proxy to declare usex for package managers or EAPIs that do not provide it
1524# and use the package manager implementation when available (i.e. EAPI >= 5).
1525# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1526# otherwise echo [false output][false suffix] (defaults to "no").
1527if has "${EAPI:-0}" 0 1 2 3 4; then
1528 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1529fi
1530
1531# @FUNCTION: prune_libtool_files
1532# @USAGE: [--all|--modules]
1533# @DESCRIPTION:
1534# Locate unnecessary libtool files (.la) and libtool static archives
1535# (.a) and remove them from installation image.
1536#
1537# By default, .la files are removed whenever the static linkage can
1538# either be performed using pkg-config or doesn't introduce additional
1539# flags.
1540#
1541# If '--modules' argument is passed, .la files for modules (plugins) are
1542# removed as well. This is usually useful when the package installs
1543# plugins and the plugin loader does not use .la files.
1544#
1545# If '--all' argument is passed, all .la files are removed without
1546# performing any heuristic on them. You shouldn't ever use that,
1547# and instead report a bug in the algorithm instead.
1548#
1549# The .a files are only removed whenever corresponding .la files state
1550# that they should not be linked to, i.e. whenever these files
1551# correspond to plugins.
1552#
1553# Note: if your package installs both static libraries and .pc files
1554# which use variable substitution for -l flags, you need to add
1555# pkg-config to your DEPEND.
1556prune_libtool_files() {
1557 debug-print-function ${FUNCNAME} "$@"
1558
1559 local removing_all removing_modules opt
1560 _eutils_eprefix_init
1561 for opt; do
1562 case "${opt}" in
1563 --all)
1564 removing_all=1
1565 removing_modules=1
1566 ;;
1567 --modules)
1568 removing_modules=1
1569 ;;
1570 *)
1571 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1572 esac
1573 done
1574
1575 local f
1576 local queue=()
1577 while IFS= read -r -d '' f; do # for all .la files
1578 local archivefile=${f/%.la/.a}
1579
1580 # The following check is done by libtool itself.
1581 # It helps us avoid removing random files which match '*.la',
1582 # see bug #468380.
1583 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1584 continue
1585 fi
1586
1587 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1588 local reason= pkgconfig_scanned=
1589 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1590
1591 if [[ ${snotlink} == yes ]]; then
1592
1593 # Remove static libs we're not supposed to link against.
1594 if [[ -f ${archivefile} ]]; then
1595 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1596 queue+=( "${archivefile}" )
1597 fi
1598
1599 # The .la file may be used by a module loader, so avoid removing it
1600 # unless explicitly requested.
1601 if [[ ${removing_modules} ]]; then
1602 reason='module'
1603 fi
1604
1605 else
1606
1607 # Remove .la files when:
1608 # - user explicitly wants us to remove all .la files,
1609 # - respective static archive doesn't exist,
1610 # - they are covered by a .pc file already,
1611 # - they don't provide any new information (no libs & no flags).
1612
1613 if [[ ${removing_all} ]]; then
1614 reason='requested'
1615 elif [[ ! -f ${archivefile} ]]; then
1616 reason='no static archive'
1617 elif [[ ! $(sed -nre \
1618 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1619 "${f}") ]]; then
1620 reason='no libs & flags'
1621 else
1622 if [[ ! ${pkgconfig_scanned} ]]; then
1623 # Create a list of all .pc-covered libs.
1624 local pc_libs=()
1625 if [[ ! ${removing_all} ]]; then
1626 local pc
1627 local tf=${T}/prune-lt-files.pc
1628 local pkgconf=$(tc-getPKG_CONFIG)
1629
1630 while IFS= read -r -d '' pc; do # for all .pc files
1631 local arg libs
1632
1633 # Use pkg-config if available (and works),
1634 # fallback to sed.
1635 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1636 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1637 libs=$(${pkgconf} --libs "${tf}")
1638 else
1639 libs=$(sed -ne 's/^Libs://p' "${pc}")
1640 fi
1641
1642 for arg in ${libs}; do
1643 if [[ ${arg} == -l* ]]; then
1644 if [[ ${arg} == '*$*' ]]; then
1645 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1646 eqawarn "(arg: ${arg})"
1647 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1648 fi
1649
1650 pc_libs+=( lib${arg#-l}.la )
1651 fi
1652 done
1653 done < <(find "${D}" -type f -name '*.pc' -print0)
1654
1655 rm -f "${tf}"
257 fi 1656 fi
1657
1658 pkgconfig_scanned=1
1659 fi # pkgconfig_scanned
1660
1661 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1662 fi # removal due to .pc
1663
1664 fi # shouldnotlink==no
1665
1666 if [[ ${reason} ]]; then
1667 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1668 queue+=( "${f}" )
1669 fi
1670 done < <(find "${ED}" -xtype f -name '*.la' -print0)
1671
1672 if [[ ${queue[@]} ]]; then
1673 rm -f "${queue[@]}"
1674 fi
1675}
1676
1677# @FUNCTION: einstalldocs
1678# @DESCRIPTION:
1679# Install documentation using DOCS and HTML_DOCS.
1680#
1681# If DOCS is declared and non-empty, all files listed in it are
1682# installed. The files must exist, otherwise the function will fail.
1683# In EAPI 4 and subsequent EAPIs DOCS may specify directories as well,
1684# in other EAPIs using directories is unsupported.
1685#
1686# If DOCS is not declared, the files matching patterns given
1687# in the default EAPI implementation of src_install will be installed.
1688# If this is undesired, DOCS can be set to empty value to prevent any
1689# documentation from being installed.
1690#
1691# If HTML_DOCS is declared and non-empty, all files and/or directories
1692# listed in it are installed as HTML docs (using dohtml).
1693#
1694# Both DOCS and HTML_DOCS can either be an array or a whitespace-
1695# separated list. Whenever directories are allowed, '<directory>/.' may
1696# be specified in order to install all files within the directory
1697# without creating a sub-directory in docdir.
1698#
1699# Passing additional options to dodoc and dohtml is not supported.
1700# If you needed such a thing, you need to call those helpers explicitly.
1701einstalldocs() {
1702 debug-print-function ${FUNCNAME} "${@}"
1703
1704 local dodoc_opts=-r
1705 has ${EAPI} 0 1 2 3 && dodoc_opts=
1706
1707 if ! declare -p DOCS &>/dev/null ; then
1708 local d
1709 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
1710 THANKS BUGS FAQ CREDITS CHANGELOG ; do
1711 if [[ -s ${d} ]] ; then
1712 dodoc "${d}" || die
258 fi 1713 fi
259 1714 done
260 if patch ${popts} --dry-run -f -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1 1715 elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
261 then 1716 if [[ ${DOCS[@]} ]] ; then
262 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1717 dodoc ${dodoc_opts} "${DOCS[@]}" || die
263 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1718 fi
264 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1719 else
265 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1720 if [[ ${DOCS} ]] ; then
266 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1721 dodoc ${dodoc_opts} ${DOCS} || die
1722 fi
1723 fi
267 1724
268 patch ${popts} -p${count} < ${PATCH_TARGET} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1 1725 if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
1726 if [[ ${HTML_DOCS[@]} ]] ; then
1727 dohtml -r "${HTML_DOCS[@]}" || die
1728 fi
1729 else
1730 if [[ ${HTML_DOCS} ]] ; then
1731 dohtml -r ${HTML_DOCS} || die
1732 fi
1733 fi
269 1734
270 if [ "$?" -ne 0 ] 1735 return 0
271 then 1736}
272 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279 1737
280 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 1738check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
281 1739
1740# @FUNCTION: optfeature
1741# @USAGE: <short description> <package atom to match> [other atoms]
1742# @DESCRIPTION:
1743# Print out a message suggesting an optional package (or packages) which
1744# provide the described functionality
1745#
1746# The following snippet would suggest app-misc/foo for optional foo support,
1747# app-misc/bar or app-misc/baz[bar] for optional bar support
1748# and either both app-misc/a and app-misc/b or app-misc/c for alphabet support.
1749# @CODE
1750# optfeature "foo support" app-misc/foo
1751# optfeature "bar support" app-misc/bar app-misc/baz[bar]
1752# optfeature "alphabet support" "app-misc/a app-misc/b" app-misc/c
1753# @CODE
1754optfeature() {
1755 debug-print-function ${FUNCNAME} "$@"
1756 local i j msg
1757 local desc=$1
1758 local flag=0
1759 shift
1760 for i; do
1761 for j in ${i}; do
1762 if has_version "${j}"; then
1763 flag=1
1764 else
1765 flag=0
282 break 1766 break
283 fi 1767 fi
284 1768 done
285 count=$((count + 1)) 1769 if [[ ${flag} -eq 1 ]]; then
1770 break
1771 fi
1772 done
1773 if [[ ${flag} -eq 0 ]]; then
1774 for i; do
1775 msg=" "
1776 for j in ${i}; do
1777 msg+=" ${j} and"
286 done 1778 done
287 1779 msg="${msg:0: -4} for ${desc}"
288 if [ "${PATCH_SUFFIX}" != "patch" ] 1780 elog "${msg}"
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${x##*/}!"
297 eerror
298 eerror "Include in your bugreport the contents of:"
299 eerror
300 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
301 echo
302 die "Failed Patch: ${x##*/}!"
303 fi
304
305 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
306
307 eend 0
308 fi
309 done 1781 done
310 if [ "${SINGLE_PATCH}" = "no" ]
311 then
312 einfo "Done with patching"
313 fi
314}
315
316# This function check how many cpu's are present, and then set
317# -j in MAKEOPTS accordingly.
318#
319# Thanks to nall <nall@gentoo.org> for this.
320#
321get_number_of_jobs() {
322 local jobs=0
323
324 if [ ! -r /proc/cpuinfo ]
325 then
326 return 1
327 fi
328
329 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
330 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
331 then
332 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
333 ADMINPARAM="${ADMINOPTS##*-j}"
334 ADMINPARAM="${ADMINPARAM%% -*}"
335 fi
336
337 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j[0-9]*::g'`"
338
339 if [ "${ARCH}" = "x86" ]
340 then
341 # x86 always has "processor"
342 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
343
344 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
345 then
346 # sparc always has "ncpus active"
347 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
348
349 elif [ "${ARCH}" = "alpha" ]
350 then
351 # alpha has "cpus active", but only when compiled with SMP
352 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
353 then
354 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
355 else
356 jobs=2
357 fi 1782 fi
358 1783}
359 elif [ "${ARCH}" = "ppc" ] 1784
360 then
361 # ppc has "processor", but only when compiled with SMP
362 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
363 then
364 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
365 else
366 jobs=2
367 fi
368 elif [ "${ARCH}" = "mips" ]
369 then
370 # mips always has "processor"
371 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
372
373 else
374 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
375 die "Unknown ARCH -- ${ARCH}!"
376 fi 1785fi
377
378 # Make sure the number is valid ...
379 if [ "${jobs}" -lt 1 ]
380 then
381 jobs=1
382 fi
383
384 if [ -n "${ADMINPARAM}" ]
385 then
386 if [ "${jobs}" -gt "${ADMINPARAM}" ]
387 then
388 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
389 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
390 else
391 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
392 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
393 fi
394 fi
395}
396

Legend:
Removed from v.1.15  
changed lines
  Added in v.1.443

  ViewVC Help
Powered by ViewVC 1.1.20